/*
	
	SettingsView.h
*/

#ifndef SETTINGS_VIEW_H
#define SETTINGS_VIEW_H

#include <RadioButton.h>
#include <View.h>

#include "AnalogClock.h"
#include "CalendarView.h"
#include "DateTimeEdit.h"

class TSettingsView:public BView {
	public:
		TSettingsView(BRect frame);
		virtual ~TSettingsView();
		
		virtual void AttachedToWindow();
		virtual void Draw(BRect updaterect);
		virtual void MessageReceived(BMessage *message);
		
		void ChangeRTCSetting();
		
		bool GMTime();
	private:
		void InitView();
		void ReadFiles(); // reads RTC_time_settings
		void UpdateDateTime(BMessage *message);
		
		BRect f_temp;
		BRadioButton *f_local;
		BRadioButton *f_gmt;
		TDateEdit *f_dateedit;
		TTimeEdit *f_timeedit;
		TCalendarView *f_calendar;
		TAnalogClock *f_clock;
		bool f_islocal; // local or gmt?
};

#endif
